VERSION 5.00
Begin VB.UserControl CustomButton 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   ClientHeight    =   405
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1275
   EditAtDesignTime=   -1  'True
   ScaleHeight     =   30
   ScaleMode       =   0  'User
   ScaleWidth      =   80
   ToolboxBitmap   =   "CustomButton.ctx":0000
End
Attribute VB_Name = "CustomButton"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Rectangle Dimentions Type Declaration
Private Type RECT
  Left   As Long
  Top    As Long
  Right  As Long
  Bottom As Long
End Type

' X/Y Coordinates Type Declaration
Private Type POINTAPI
  X As Long
  Y As Long
End Type

' Appearance Enumeration
Public Enum AppearanceConstants
  acFlat = 0
  ac3D = 1
End Enum

' Application Constants
Private Const APPNAME = "CustomButton"

' Inner Boarder Constants
Private Const BDR_RAISEDINNER = &H4 '4
Private Const BDR_SUNKENINNER = &H8 '8

' Outer Boarder Constants
Private Const BDR_RAISEDOUTER = &H1 '1
Private Const BDR_SUNKENOUTER = &H2 '2

' Boarder Constants
Private Const EDGE_BUMP = (BDR_RAISEDOUTER Or BDR_SUNKENINNER)   ' 9
Private Const EDGE_ETCHED = (BDR_SUNKENOUTER Or BDR_RAISEDINNER) ' 6
Private Const EDGE_RAISED = (BDR_RAISEDOUTER Or BDR_RAISEDINNER) ' 5
Private Const EDGE_SUNKEN = (BDR_SUNKENOUTER Or BDR_SUNKENINNER) ' 10

' Boarder Type Constants
' BF_ADJUST                  = If this flag is passed, shrink the rectangle pointed to by the qrc parameter to exclude the edges that were drawn. If this flag is not passed, then do not change the rectangle pointed to by the qrc parameter. .
' BF_BOTTOM                  = Bottom of border rectangle.
' BF_BOTTOMLEFT              = Bottom and left side of border rectangle.
' BF_BOTTOMRIGHT             = Bottom and right side of border rectangle.
' BF_DIAGONAL                = Diagonal border.
' BF_DIAGONAL_ENDBOTTOMLEFT  = Diagonal border. The end point is the bottom-left corner of the rectangle; the origin is top-right corner.
' BF_DIAGONAL_ENDBOTTOMRIGHT = Diagonal border. The end point is the bottom-right corner of the rectangle; the origin is top-left corner.
' BF_DIAGONAL_ENDTOPLEFT     = Diagonal border. The end point is the top-left corner of the rectangle; the origin is bottom-right corner.
' BF_DIAGONAL_ENDTOPRIGHT    = Diagonal border. The end point is the top-right corner of the rectangle; the origin is bottom-left corner.
' BF_FLAT                    = Flat border.
' BF_LEFT                    = Left side of border rectangle.
' BF_MIDDLE                  = Interior of rectangle to be filled.
' BF_MONO                    = One-dimensional border.
' BF_RECT                    = Entire border rectangle.
' BF_RIGHT                   = Right side of border rectangle.
' BF_SOFT                    = Soft buttons instead of tiles.
' BF_TOP                     = Top of border rectangle.
' BF_TOPLEFT                 = Top and left side of border rectangle.
' BF_TOPRIGHT                = Top and right side of border rectangle.
Private Const BF_ADJUST = &H2000 ' 8192
Private Const BF_BOTTOM = &H8    ' 8
Private Const BF_DIAGONAL = &H10 ' 16
Private Const BF_FLAT = &H4000   ' 16384
Private Const BF_LEFT = &H1      ' 1
Private Const BF_MIDDLE = &H800  ' 2048
Private Const BF_MONO = &H8000   ' -32768
Private Const BF_RIGHT = &H4     ' 4
Private Const BF_SOFT = &H1000   ' 4096
Private Const BF_TOP = &H2       ' 2
Private Const BF_RECT = (BF_LEFT Or BF_TOP Or BF_RIGHT Or BF_BOTTOM)              ' 15
Private Const BF_BOTTOMLEFT = (BF_BOTTOM Or BF_LEFT)                              ' 9
Private Const BF_BOTTOMRIGHT = (BF_BOTTOM Or BF_RIGHT)                            ' 12
Private Const BF_TOPLEFT = (BF_TOP Or BF_LEFT)                                    ' 3
Private Const BF_TOPRIGHT = (BF_TOP Or BF_RIGHT)                                  ' 6
Private Const BF_DIAGONAL_ENDBOTTOMLEFT = (BF_DIAGONAL Or BF_BOTTOM Or BF_LEFT)   ' 25
Private Const BF_DIAGONAL_ENDBOTTOMRIGHT = (BF_DIAGONAL Or BF_BOTTOM Or BF_RIGHT) ' 28
Private Const BF_DIAGONAL_ENDTOPLEFT = (BF_DIAGONAL Or BF_TOP Or BF_LEFT)         ' 19
Private Const BF_DIAGONAL_ENDTOPRIGHT = (BF_DIAGONAL Or BF_TOP Or BF_RIGHT)       ' 22

' Property Default Values
Private Const defAppearance = 1 '3D
Private Const defCaption = APPNAME
Private Const defEnabled = True
Private Const defBackColor = vbButtonFace
Private Const defForeColor = vbButtonText
Private Const defStyle = 0 'Standard
Private Const defFontName = "MS Sans Serif"
Private Const defFontSize = 8
Private Const defFontBold = False
Private Const defFontItalic = False
Private Const defFontUnderline = False
Private Const defFontStrikeThru = False

' Property Variables
Private cbAppearance As AppearanceConstants
Private cbCaption    As String
Private cbStyle      As ButtonConstants
Private cbBackColor  As OLE_COLOR
Private cbForeColor  As OLE_COLOR
Private cbPicture    As StdPicture

' Internal Variable Declarations
Private BtnDepressed As Boolean
Private HasFocus     As Boolean
Private TheFlags     As Long
Private TheEdge      As Long
Private LastErrNum   As Long
Private LastErrMsg   As String
Private SpacePressed As Boolean

' Win32 API Declarations
Private Declare Function DrawEdge Lib "user32" (ByVal hdc As Long, qrc As RECT, ByVal edge As Long, ByVal grfFlags As Long) As Long
Private Declare Function OleTranslateColor Lib "olepro32.dll" (ByVal OLE_COLOR As Long, ByVal HPALETTE As Long, pColorRef As Long) As Long


'========================================================================================
'                           ACTIVEX CONTROL EVENT DECLARATIONS
'========================================================================================


Public Event Click()
Public Event DblClick()
Public Event ErrorOccured(ByVal Err_Source As String, ByVal Err_Number As Long, ByVal Err_Description As String)
Attribute ErrorOccured.VB_Description = "If an error occurs within this control, the ErrorOccured event is fired with the error information."
Public Event Hide()
Public Event KeyDown(KeyCode As Integer, Shift As Integer)
Public Event KeyPress(KeyAscii As Integer)
Public Event KeyUp(KeyCode As Integer, Shift As Integer)
Public Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLECompleteDrag(Effect As Long)
Public Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
Public Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
Public Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
Public Event OLESetData(Data As DataObject, DataFormat As Integer)
Public Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
Public Event Paint()
Public Event Resize()
Public Event Show()


'========================================================================================
'                            ACTIVEX CONTROL INITIALIZATIONS
'========================================================================================


Private Sub UserControl_Initialize()
On Error Resume Next
  
  ' Set the form to automatically refresh information painted onto it
  UserControl.AutoRedraw = True
  
  ' Set the scale to PIXELS because the Windows API works with PIXELS, not TWIPS
  UserControl.ScaleMode = vbPixels
  
  ' Set the default property values
  Me.Appearance = defAppearance
  Me.BackColor = TranslateColor(defBackColor)
  Me.ForeColor = TranslateColor(defForeColor)
  Me.Caption = defCaption
  Me.Enabled = defEnabled
  Set Me.Font = UserControl.Font
  Me.Style = defStyle
  
  ' Draw the button initially
  DrawIt
  
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  
  With PropBag
    Set Me.Picture = .ReadProperty("Picture", Nothing)
    Me.Appearance = CLng(.ReadProperty("Appearance", defAppearance))
    Me.BackColor = CLng(.ReadProperty("BackColor", defBackColor))
    Me.Caption = CStr(.ReadProperty("Caption", defCaption))
    Me.Enabled = CBool(.ReadProperty("Enabled", defEnabled))
    Me.Font.Name = CStr(.ReadProperty("FontName", defFontName))
    Me.Font.Size = CCur(.ReadProperty("FontSize", defFontSize))
    Me.Font.Bold = CBool(.ReadProperty("FontBold", defFontBold))
    Me.Font.Italic = CBool(.ReadProperty("FontItalic", defFontItalic))
    Me.Font.Underline = CBool(.ReadProperty("FontUnderline", defFontUnderline))
    Me.Font.Strikethrough = CBool(.ReadProperty("FontStrikeThru", defFontStrikeThru))
    Me.ForeColor = CLng(.ReadProperty("ForeColor", defForeColor))
    Me.Style = CLng(.ReadProperty("Style", defStyle))
  End With
  
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
On Error Resume Next
  
  With PropBag
    .WriteProperty "Picture", cbPicture, Nothing
    .WriteProperty "Appearance", CStr(cbAppearance), CStr(defAppearance)
    .WriteProperty "BackColor", CStr(cbBackColor), CStr(defBackColor)
    .WriteProperty "Caption", CStr(cbCaption), CStr(defCaption)
    .WriteProperty "Enabled", CStr(UserControl.Enabled), CStr(defEnabled)
    .WriteProperty "FontName", CStr(UserControl.Font.Name), CStr(defFontName)
    .WriteProperty "FontSize", CStr(UserControl.Font.Size), CStr(defFontSize)
    .WriteProperty "FontBold", CStr(UserControl.Font.Bold), CStr(defFontBold)
    .WriteProperty "FontItalic", CStr(UserControl.Font.Italic), CStr(defFontItalic)
    .WriteProperty "FontUnderline", CStr(UserControl.Font.Underline), CStr(defFontUnderline)
    .WriteProperty "FontStrikeThru", CStr(UserControl.Font.Strikethrough), CStr(defFontStrikeThru)
    .WriteProperty "ForeColor", CStr(cbForeColor), CStr(defForeColor)
    .WriteProperty "Style", CStr(cbStyle), CStr(defStyle)
  End With
  
End Sub


'========================================================================================
'                            ACTIVEX CONTROL EVENTS
'========================================================================================


Private Sub UserControl_Click()
  
  RaiseEvent Click
  
End Sub

Private Sub UserControl_DblClick()
  
  RaiseEvent DblClick
  
End Sub

Private Sub UserControl_GotFocus()
  
  HasFocus = True
  DrawIt BtnDepressed
  DoEvents
  
End Sub

Private Sub UserControl_LostFocus()
  
  HasFocus = False
  DrawIt BtnDepressed
  DoEvents
  
End Sub

Private Sub UserControl_Hide()
  
  RaiseEvent Hide
  
End Sub

Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
  
  ' Sends click event and button is depressed on space bar press
  If KeyCode = 32 Then     ' <SPACE>
    SpacePressed = True
    BtnDepressed = True
    DrawIt BtnDepressed
    DoEvents
    
  ' Sends click event on enter key press
  ElseIf KeyCode = 13 Then ' <ENTER>
    SpacePressed = True
  End If
  
  RaiseEvent KeyDown(KeyCode, Shift)
  
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
  
  RaiseEvent KeyPress(KeyAscii)
  
End Sub

Private Sub UserControl_KeyUp(KeyCode As Integer, Shift As Integer)
  
  If SpacePressed = True Then
    SpacePressed = False
    BtnDepressed = False
    DrawIt BtnDepressed
    DoEvents
    RaiseEvent Click
  End If
  
  RaiseEvent KeyUp(KeyCode, Shift)
  
End Sub

Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  BtnDepressed = True
  DrawIt BtnDepressed
  DoEvents
  
  RaiseEvent MouseDown(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  RaiseEvent MouseMove(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  BtnDepressed = False
  DrawIt BtnDepressed
  DoEvents
  
  RaiseEvent MouseUp(Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_OLECompleteDrag(Effect As Long)
  
  RaiseEvent OLECompleteDrag(Effect)
  
End Sub

Private Sub UserControl_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single)
  
  RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, X, Y)
  
End Sub

Private Sub UserControl_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, X As Single, Y As Single, State As Integer)
  
  RaiseEvent OLEDragOver(Data, Effect, Button, Shift, X, Y, State)
  
End Sub

Private Sub UserControl_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
  
  RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
  
End Sub

Private Sub UserControl_OLESetData(Data As DataObject, DataFormat As Integer)
  
  RaiseEvent OLESetData(Data, DataFormat)
  
End Sub

Private Sub UserControl_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
  
  RaiseEvent OLEStartDrag(Data, AllowedEffects)
  
End Sub

Private Sub UserControl_Paint()
  
  RaiseEvent Paint
  
End Sub

Private Sub UserControl_Resize()
  
  DrawIt BtnDepressed
  
End Sub

Private Sub UserControl_Show()
  
  RaiseEvent Show
  
End Sub


'========================================================================================
'                              ACTIVEX PROPERTIES
'========================================================================================


Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
Attribute BackColor.VB_UserMemId = -501
  
  BackColor = cbBackColor
  
End Property

Public Property Let BackColor(ByVal NewValue As OLE_COLOR)
  
  cbBackColor = NewValue
  DrawIt BtnDepressed
  PropertyChanged "BackColor"
  
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
Attribute ForeColor.VB_UserMemId = -513
  
  ForeColor = cbForeColor
  
End Property

Public Property Let ForeColor(ByVal NewValue As OLE_COLOR)
  
  cbForeColor = NewValue
  DrawIt BtnDepressed
  PropertyChanged "ForeColor"
  
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
  
  Set Font = UserControl.Font
  
End Property

Public Property Set Font(ByVal NewValue As Font)
  
  Set UserControl.Font = NewValue
  DrawIt BtnDepressed
  PropertyChanged "Font"
  
End Property

Public Property Get Appearance() As AppearanceConstants
Attribute Appearance.VB_Description = "Returns/sets whether or not an object is painted at run time with 3-D effects."
  
  Appearance = cbAppearance
  
End Property

Public Property Let Appearance(ByVal NewValue As AppearanceConstants)
  
  cbAppearance = NewValue
  DrawIt BtnDepressed
  PropertyChanged "Appearance"
  
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text  displayed in an object's titlebar or below an object's icon."
Attribute Caption.VB_UserMemId = -518
  
  Caption = cbCaption
  
End Property

Public Property Let Caption(ByVal NewValue As String)
  
  cbCaption = NewValue
  DrawIt BtnDepressed
  PropertyChanged "Caption"
  
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
Attribute Enabled.VB_UserMemId = -514
  
  Enabled = UserControl.Enabled
  
End Property

Public Property Let Enabled(ByVal NewValue As Boolean)
  
  UserControl.Enabled = NewValue
  PropertyChanged "Enabled"
  
End Property

Public Property Get Style() As ButtonConstants
Attribute Style.VB_Description = "Returns/sets the appearance of the control, whether standard (standard Windows style) or graphical (with customizations)"
  
  Style = cbStyle
  
End Property

Public Property Let Style(ByVal NewValue As ButtonConstants)
  
  cbStyle = NewValue
  DrawIt BtnDepressed
  PropertyChanged "Enabled"
  
End Property

Public Property Get Picture() As Picture
  
  Set Picture = cbPicture
  
End Property

Public Property Set Picture(ByVal NewValue As Picture)
  
  Set cbPicture = NewValue
  DrawIt BtnDepressed
  PropertyChanged "Picture"
  
End Property


'========================================================================================
'                                ACTIVEX METHODS
'========================================================================================


Public Sub About()
Attribute About.VB_Description = "Displays the About dialog for this control."
Attribute About.VB_UserMemId = -552
On Error Resume Next
  
  frmAbout.Show vbModal
  
End Sub

Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
Attribute Refresh.VB_UserMemId = -550
On Error Resume Next
  
  DrawIt BtnDepressed
  
End Sub


'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


Private Function DrawIt(Optional ByVal Depressed As Boolean) As Boolean
On Error GoTo ErrorTrap
  
  Dim MyCounter   As Integer
  Dim CenterX     As Single
  Dim CenterY     As Single
  Dim Brush       As Long
  Dim ButtonRECT  As RECT
  Dim OutlineRECT As RECT
  
  ' Setup the dimentions of the display button
  If HasFocus = False Then
    With ButtonRECT
      .Top = 0
      .Left = 0
      .Bottom = UserControl.ScaleHeight
      .Right = UserControl.ScaleWidth
    End With
  Else
    With ButtonRECT
      .Top = 1
      .Left = 1
      .Bottom = UserControl.ScaleHeight - 1
      .Right = UserControl.ScaleWidth - 1
    End With
  End If
  
  With OutlineRECT
    .Top = 0
    .Left = 0
    .Bottom = UserControl.ScaleHeight
    .Right = UserControl.ScaleWidth
  End With
  
  ' Clear the UserControl to start with a clean area
  UserControl.Cls
  
  ' Set the proper BackColor / ForeColor depending on the style
  If cbStyle = vbButtonStandard Then
    UserControl.BackColor = vbButtonFace
    UserControl.ForeColor = vbButtonText
  ElseIf cbStyle = vbButtonGraphical Then
    UserControl.BackColor = cbBackColor
    UserControl.ForeColor = cbForeColor
    If Not cbPicture Is Nothing Then UserControl.PaintPicture cbPicture, 0, 0
  End If
  
  ' Get what the flags should be based on the ActiveX control's properties
  If cbAppearance = ac3D Then
    If Depressed = False Then
      TheEdge = BDR_RAISEDINNER Or BDR_RAISEDOUTER
      TheFlags = BF_TOP Or BF_BOTTOM Or BF_LEFT Or BF_RIGHT
    Else
      TheEdge = BDR_SUNKENINNER Or BDR_SUNKENOUTER
      TheFlags = BF_TOP Or BF_BOTTOM Or BF_LEFT Or BF_RIGHT
    End If
  ElseIf cbAppearance = acFlat Then
    If Depressed = False Then
      TheEdge = BDR_RAISEDINNER
      TheFlags = BF_TOP Or BF_BOTTOM Or BF_LEFT Or BF_RIGHT
    Else
      TheEdge = BDR_SUNKENOUTER
      TheFlags = BF_TOP Or BF_BOTTOM Or BF_LEFT Or BF_RIGHT
    End If
  End If
  
  ' Add the BF_SOFT and/or BF_FLAT flags depending on the button state to
  ' make it look & feel more like a standard CommandButton when being clicked
  If HasFocus = True Then
    If cbAppearance = ac3D Then
      TheFlags = TheFlags Or BF_SOFT
    End If
    If Depressed = True Then
      TheFlags = TheFlags Or BF_FLAT
    End If
  End If
  
  ' Draw the button
  If DrawEdge(UserControl.hdc, ButtonRECT, TheEdge, TheFlags) = 0 Then
    GetLastErr_Msg Err.LastDllError, "DrawEdge", False, LastErrNum, LastErrMsg
    RaiseEvent ErrorOccured(APPNAME & " - DrawIt", LastErrNum, LastErrMsg)
  Else
    If HasFocus = True Then
      If DrawEdge(UserControl.hdc, OutlineRECT, BDR_SUNKENOUTER, BF_TOP Or BF_BOTTOM Or BF_LEFT Or BF_RIGHT Or BF_MONO) = 0 Then
        GetLastErr_Msg Err.LastDllError, "DrawEdge", False, LastErrNum, LastErrMsg
        RaiseEvent ErrorOccured(APPNAME & " - DrawIt", LastErrNum, LastErrMsg)
      End If
    End If
  End If
  
  ' Put the text on the button in the center
  If Depressed = True Then
    UserControl.CurrentX = (CLng(UserControl.ScaleWidth / 2) - CLng(UserControl.TextWidth(cbCaption) / 2)) + 1
    UserControl.CurrentY = (CLng(UserControl.ScaleHeight / 2) - CLng(UserControl.TextHeight(cbCaption) / 2)) + 1
  Else
    UserControl.CurrentX = CLng(UserControl.ScaleWidth / 2) - CLng(UserControl.TextWidth(cbCaption) / 2)
    UserControl.CurrentY = CLng(UserControl.ScaleHeight / 2) - CLng(UserControl.TextHeight(cbCaption) / 2)
  End If
  UserControl.Print cbCaption
  
  ' Repaint the form to show the changes
  UserControl.Refresh
  
  Exit Function
  
ErrorTrap:
  
  If Err.Number = 0 Or Err.Number = 20 Then
    Resume Next
  Else
    RaiseEvent ErrorOccured(APPNAME & " - DrawIt", Err.Number, Err.Description)
    Err.Clear
    Err.Number = 0
  End If
  
End Function

' Function that converts automation colors such as "vbButtonFace" to standard
' color such as "12632256".  It is safest to pass all colors through this
' function to make sure that if a user passes a color like "Me.BackColor" and
' the BackColor is vbButtonFace, it won't mess up any of the API's that are
' expecting a normal color value.
Private Function TranslateColor(ByVal oClr As OLE_COLOR, Optional ByVal hPal As Long = 0) As Long
On Error Resume Next
  
  If OleTranslateColor(oClr, hPal, TranslateColor) Then TranslateColor = -1
  
End Function
